#include <cassert>

#include <iostream>
using std::endl;

#include <iomanip>
using std::setw;

#include <iostream>
using std::ostream;

void format(ostream &os, const double v[], int N)
{
	for (int i = 0; i < N; ++i)
	{
		os << ( i == 0 ? "/" : ( i == N-1 ? "\\" : "|" ));
			os << setw(4) << v[i];
		os << ( i == 0 ? " \\" : ( i == N-1 ? " /" : " |" )) << endl;
	}
}

void format(ostream &os, const double A[], int N, int M)
{
	for (int i = 0; i < N; ++i)
	{
		os << ( i == 0 ? "/" : ( i == N-1 ? "\\" : "|" ));
		for (int j = 0; j < M; ++j)
			os << setw(4) << A[M*i+j];
		os << ( i == 0 ? " \\" : ( i == N-1 ? " /" : " |" )) << endl;
	}
}

double determinant2(const double A[4])
{
	return A[0]*A[3] - A[1]*A[2];
}

double determinant3(const double A[9])
{
	// (!) replace 0 whith the correct return value:
	return 0;
}

double determinant(const double A[], int N, int N1 = -1, int* row_index = NULL, int* column_index = NULL)
{
	if (N1 == -1) N1 = N;
	int default_index[N]; // storage for default_index
	int* ri; // pointer to row index
	int *ci; // pointer to column index
	if (row_index == NULL) // if no row_index was provided
	{
		assert(N1 == N);
		for (int i = 0; i < N; ++i)
			default_index[i] = i; // assign default_index = { 0, 1, ..., N-1 }
		ri = default_index; // ri points to default_index array
		ci = default_index; // ci points to default_index array
	}
	else
	{
		ri = row_index; // ri points to the provided row_index
		ci = column_index; // ci points to the provided column_index
	}
	if (N1 == 1) return A[N*ri[0]+ci[0]]; // trivial return if minor is of size 1

	double sum = 0.0;
	for (int j = 0; j < N1; ++j)
	{
		int reduced_row_index[N]; // storage for reduced_row_index
		int reduced_column_index[N]; // storage for reduced_column_index

		// (!) write code to assign reduced_row_index = { ri[1], ..., ri[N1-1], filler }

		// (!) write code to assign reduced_column_index = { ci[0], ..., ci[j-1], ci[j+1], ..., ci[N1-1], filler }

		sum += (j%2 == 0 ? 1 : -1)*A[N*ri[0]+ci[j]]*determinant(A,N,N1-1,reduced_row_index,reduced_column_index);
	}
	return sum;
}

double inner_prod(const double u[], const double v[], int N)
{
	double sum;
	// (!) add your code here
	return sum;
}

void outer_prod(double out[], const double u[], const double v[], int N, int M)
{
	// (!) add your code here
}

void multiply(double out[], const double inL[], const double inR[], int N, int K, int M)
{
	// (!) add your code here
}

void multiply_Rtranspose(double out[], const double inL[], const double inR[], int N, int K, int M)
{
	// (!) add your code here
}
