#include <iostream>
using std::cout;
using std::endl;

#include "linalg.h"

int main()
{
	double u[4] = { 1.0, -2.0, 0.5, 0.3 };
	double v[3] = { -1.0, 1.0, 3.0 };
	double w[3] = { -0.25, 0.75, 1.0/3.0 };
	cout << "u =" << endl;
	format(cout,u,4);
	cout << endl << "v =" << endl;
	format(cout,v,3);
	
	cout << endl << "Inner product:" << endl;
	cout << "(u,u) = " << inner_prod(u,u,4) << endl;
	cout << "(v,w) = " << inner_prod(v,w,3) << endl;
	double A[4*3];

	cout << endl << "Outer product:" << endl;
	cout << "u.v =" << endl;
	outer_prod(A,u,v,4,3);
	format(cout,A,4,3);
}